%Please run this script  Comp_SRColor to compress one of the images (enter number 1 to 15)
%To run the MATLAB version of HBW_OMP2D uncommet line 70 and comment lines 71-73
%A compilable version of the C++ Mex file for HBW_OMP2D_Mex is available
%on http://www.nonlinear-approx.info/examples/node0.html
%
clear c mIApp  nCoe mI SImage mImage mIAppq mIAppwq mIwq mIAppw mIw
%
clear ImageNumber
%
ImageNumber=input('Input the Image Number ')
%
get_settings_table4
%
thr=del;
bw=Nb;%blocksize 
BlockWidth=bw;
%
[A]=double(imread(ImagePath));
%
s=floor(size(A(:,:,1))/bw);
%
A=A(1:s(1)*bw,1:s(2)*bw,:); %resize the images to be divisible by BlockWidth;
%
MaxIntb=255; %assume 8-bit image
Lz=size(A,3);
[dImx,dImy]=size(A(:,:,1));
Idim=dImx*dImy;
Nz=Lz;
%=====================================================
%Generates the dct transformation 
Tz=NormDict(DCos(Lz,Nz,1)); %
ITz=Tz'; %inverse dct
%======================================================
%Apply the transformation across the channels
mImage=Tdimz(A,Lz,Nz,Tz);
%===================================================
wlevel=5
tic;
%Perform the wavelet transform
for z=1:Nz
SImage(:,:,z)=waveletcdf97(mImage(:,:,z),wlevel);
end
%concatenate the channels
mI=[SImage(:,:,1); SImage(:,:,2); SImage(:,:,3)];
clear cmI
[cmI, nYBlocks, nXBlocks] = BlockImage(mI, BlockWidth); %for blocking the image in cells
%
NBX=nXBlocks;
NBY=nYBlocks;
%
[Lx,Ly]=size(cmI{1,1}); %get block size
delta=1/(Lx*Ly);
clear cmIa
cmIa= cell(nYBlocks,nXBlocks);
tol=MaxIntb^2/(10^(pss/10));%set the approximation quality according to the desired PSNR (ss)
tol3=(tol*(numel(A)));%tolerance for total PSNR
%
%====== input dictionaries===================
get_mixed_dict_wd %get dictionaries Dx and Dy
[Lx,Nx]=size(Dx);
[Ly,Ny]=size(Dy);
%=======================================================
%
%=======Approximation of the image partition=============
q=0;
indx=[];
indy=[];
SRt=2% to stop by PSNR
No=numel(A)/SRt;
%[cmIa,Di1,Di2,beta,c,Q,Nat]=HBW_OMP2D(cmI,Dx,Dy,tol3,No);
[cmIa,Di1,Di2,beta,c,Q,Nat]=HBW_OMP2D_Mex(cmI,Dx,Dy,tol3,No);
%=====Convert coef. format from  Mex========================
conv_coe_hbw_mex
%===================================================================================
%
clear mIApp mIAppw mIw
mIw=cell2mat(cmIa);%assemble the images
%Recover image from split channels and invert the transformations
for z=1:Lz
mIAppw(:,:,z)=mIw(1+(z-1)*dImx:z*dImx,:);
mIApp(:,:,z)=waveletcdf97(mIAppw(:,:,z),-wlevel); %inverse WT
end
%========== invert the transformation Tz==========
Ar=Tdimz(mIApp,Lz,Nz,ITz);
%====================================
SR3d=numel(A)/Nat;
sprintf('Global SR, (SR3D) %1.1f', SR3d)
%===============================================
PSNR3d=CalcPSNR3D(A,Ar,255);
sprintf('global PSNR3d %1.1f', PSNR3d)
sprintf('Approximation Time (s)')
Approx_time=toc
%=======================Quantize============================
[cq,cqr,onein,cDi1,cDi2,csi,sc]=quant_coef(c,Di1,Di2,Nx,Ny,NBX,NBY,del,thr);
%
%
clear ch2
q=0;
for i=1:NBY; %Check
for j=1:NBX; %Check
q=q+1;
ch2{i,j}=zeros(Lx,Ly);
k2(q)=numel(cqr{q}); 
for n=1:k2(q)
ch2{i,j}=ch2{i,j}+Dx(:,cDi1{q}(n))*cqr{q}(n)*Dy(:,cDi2{q}(n))';
end
end
end
%
clear mIAppq mIAppwq mIwq 
mIwq=cell2mat(ch2);%assemble the images
%Recover image from split channels and invert the transformations
for z=1:Lz
mIAppwq(:,:,z)=mIwq(1+(z-1)*dImx:z*dImx,:);
mIAppq(:,:,z)=waveletcdf97(mIAppwq(:,:,z),-wlevel); %inverse WT
end
%========== invert the transformation Tz==========
Arq=Tdimz(mIAppq,Lz,Nz,ITz);
%================================================
SR3dq=numel(A)/sum(k2);
sprintf('Global SR after quantization, (SR3Dq) %1.1f', SR3dq)
%================================================
PSNR3dq=CalcPSNR3D(A,Arq,255);
sprintf('global PSNR3d  after quantization (PSNR3dq) %1.1f', PSNR3dq)
NN=NBX*NBY;%number of blocks
[xC,xCC,xS]=make_strings_wd(cq,onein,csi,sc,NN);
%
%Saves the strings and shows the size of the file
%
SR_after_Quantization=numel(A)/(numel(xCC{1}))
%
[yi]=Huff06(xC);
[yc]=Huff06(xCC);
[ys]=Huff06(xS);
FileSC='SRColor/Comp_File_SRColor.mat';
save(FileSC,'yi','yc','ys','del','NBX');
fprintf('The compressed file is saved as: ')
disp(FileSC);
hs=dir(FileSC);
bpp_SR=hs.bytes*8/Idim
sprintf('PSNR_3D %1.1f', PSNR3dq)
%
